package com.bcxin.ars.dao.certificate;

import com.bcxin.ars.dto.certificate.ReplaceCompanyCertificateSearchDTO;
import com.bcxin.ars.model.certificate.GradeCertificate;
import com.bcxin.ars.model.certificate.ReplaceCompanyCertificate;
import com.com.bcxin.ars.com.abcxin.smart.core.web.validate.AjaxPageResponse;

import java.util.List;

/***
 * 换证数据库持久层
 */
public interface ReplaceCompanyCertificateDao {
	/***
	 * 保存
	 * @param replaceCompanyCertificate
	 * @return
	 */
	Long save(ReplaceCompanyCertificate replaceCompanyCertificate);
	/***
	 * 根据ID获取信息
	 * @param id
	 * @return
	 */
	ReplaceCompanyCertificate findById(long id);
	/***
	 * 更新
	 * @param replaceCompanyCertificate
	 */
	void update(ReplaceCompanyCertificate replaceCompanyCertificate);
	/***
	 * 查询换证信息
	 * @param dto 查询条件参数
	 * @param ajaxPageResponse 返回数据对象
	 * @return 查询列表
	 */
	List<ReplaceCompanyCertificate> query(ReplaceCompanyCertificateSearchDTO dto, AjaxPageResponse<ReplaceCompanyCertificate> ajaxPageResponse);
}