package com.bcxin.ars.dao.sb;

import com.bcxin.ars.dto.DataSynchronizationSearchDto;
import com.bcxin.ars.dto.ReportData;
import com.bcxin.ars.dto.report.ReportDataSearchDto;
import com.bcxin.ars.dto.sb.TraincompanyapplySearchDto;
import com.bcxin.ars.model.sb.Sponsorlicense;
import com.bcxin.ars.model.sb.Traincompanyapply;
import com.bcxin.ars.model.sys.Approval;
import com.com.bcxin.ars.com.abcxin.smart.core.web.validate.AjaxPageResponse;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface TraincompanyapplyDao {
	/**
	 *
	 * @Decription:通过id查询处理签打印内容
	 * @author：zhongjianhui
	 * @method  searchForPrintf
	 * @date：2018/10/12 17:08
	 * @params： * @param id
	 * @return java.util.Map
	 */
	Map searchForPrintf(long id);

	Traincompanyapply findById(Long id);

	Traincompanyapply findByIdWithOutCache(Long id);
	/**
	 *
	 * @Decription:批量查询
	 * @author：zhongjianhui
	 * @method  findByBatchId
	 * @date：2018/8/17 9:17
	 * @params： * @param approvalList
	 * @return java.util.List<com.bcxin.ars.model.sb.Traincompanyapply>
	 */
	List<Traincompanyapply> findByBatchId(@Param("approvalList") List<Approval> approvalList);

	List<Traincompanyapply> findByBatchIdWithOutCache(@Param("approvalList") List<Approval> approvalList);


	/**
	 *
	 * @Decription:批量更新
	 * @author：zhongjianhui
	 * @method  updateBatch
	 * @date：2018/8/17 9:20
	 * @params： * @param approvalList
	 * @return void
	 */
	void updateBatch(@Param("approvalList")List<Traincompanyapply> approvalList);

	Long save(Traincompanyapply traincompanyapply);

	void update(Traincompanyapply traincompanyapply);
	
	List<Traincompanyapply> search(TraincompanyapplySearchDto dto);
	
	Long searchCount(TraincompanyapplySearchDto dto);

	Traincompanyapply findByUser(Long userid);

    List<Traincompanyapply> searchForDataSynchronization(DataSynchronizationSearchDto searchDto);

	List<Traincompanyapply> findAll();

	List<ReportData> findByAreaReport(ReportDataSearchDto searchDto);

    int countTraincompanyapplyList(Map<Object, Object> p);

	List<Map<Object,Object>> searchTraincompanyapplyList(Map<Object, Object> p);

    Traincompanyapply findApproveByCompanyName(String companyname);

	List<Map<Object,Object>> searchForPage(TraincompanyapplySearchDto dto, AjaxPageResponse<Traincompanyapply> page);

    List<Traincompanyapply> findUnIntegrated();
}
