package com.bcxin.ars.dao.supervision;

import com.abcxin.smart.validator.annotation.DataChangeAnnotation;
import com.abcxin.smart.validator.enums.ParamType;
import com.bcxin.ars.model.supervision.CompanyComplaint;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.List;

/**
 * @author yyx
 * @date 2020/06/15
 */
@Service
public class CompanyComplaintDaoAop {
    @Autowired
    private CompanyComplaintDao companyComplaintDao;
    @DataChangeAnnotation(getEntityClazz = CompanyComplaint.class,
            getDaoClazz = CompanyComplaintDao.class,
            getParamClazz = Long.class,
            getSearchMethodName = "findByIdWithOutCache")
    public int delete(CompanyComplaint companyComplaint) {
        return companyComplaintDao.delete(companyComplaint);
    }
    @DataChangeAnnotation(getEntityClazz = CompanyComplaint.class,
            getDaoClazz = CompanyComplaintDao.class,
            getParamClazz = Long.class,
            getSearchMethodName = "findByIdWithOutCache")
    public void save(CompanyComplaint companyComplaint) {
        companyComplaintDao.save(companyComplaint);
    }

    @DataChangeAnnotation(getEntityClazz = CompanyComplaint.class,
            getDaoClazz = CompanyComplaintDao.class,
            getParamType = ParamType.ENTITY,
            getParamClazz = List.class,
            getSearchMethodName = "findByBatchIdWithOutCache")
    public void saveBatch(List<CompanyComplaint> list) {
        companyComplaintDao.saveBatch(list);
    }
}
